/Define the number of rows to put into the table
n:9000000

/Generate a random table of sym,price and size
t:([]sym:n?-2000?`3;price:n?1000.0;size:n?100.0)

testsym:10# exec distinct sym from t

/Save table as splayed table (use .Q.en because of sym column)
`:tsplayed/ set .Q.en[`:.;t]

/Delete t from the workspace to clear up
delete t from `.

/Load directory to read in the saved table (tsplayed)
\l .

/Select on a sym and time. Do 100 times to increase times
/Store result as r1 so we can compare to other queries
/Show meta of the table to highlight the lack of attribute
"ROUGH"
meta tsplayed
\t do[100;r1:select from tsplayed where sym in testsym]
r1:`sym`price`size xasc r1


/Add a `g# (grouped) attribute. This can be applied as the 
/list is sorted in ascending order, by sym
@[`:tsplayed/;`sym;`g#]

/Select on a sym and time. Do 100 times to increase times
/Store result as r2 so we can compare to other queries
/Show meta of the table to show the `s# attribute
/After timing compare to r1 to check same results
"GROUPED"
meta tsplayed
\t do[100;r2:select from tsplayed where sym in testsym]
r2:`sym`price`size xasc r2
r1~r2

/Sort ascending by sym. This will add a `s# attribute
`sym xasc `:tsplayed/

/Select on a sym and time. Do 100 times to increase times
/Store result as r3 so we can compare to other queries
/Show meta of the table to show the `s# attribute
/After timing compare to r1 to check same results
"SORTED"
meta tsplayed
\t do[100;r2:select from tsplayed where sym in testsym]
r2:`sym`price`size xasc r2
r1~r2

/Add a `p# (parted) attribute. This can be applied as the 
/list is sorted in ascending order, by sym
@[`sym xasc `:tsplayed/;`sym;`p#]

/Select on a sym and time. Do 100 times to increase times
/Store result as r4 so we can compare to other queries
/Show meta of the table to show the `s# attribute
/After timing compare to r1 to check same results
"PARTED"
meta tsplayed
\t do[100;r2:select from tsplayed where sym in testsym]
r2:`sym`price`size xasc r2
r1~r2

