/
ipc1.q simply defines the IPC functions to log messages on the screen of the server process
\

\l taq.q /load in taq.q so the clients can query tables and execute stored procedures



/open
/
Display information about the newly connected client
\

clients: (
	[h:`int$()]
	time:`time$();
	user:`$();
	host:`$();
	ip:`$();
	number:`int$()
 );
 
access: (
	[handle:"i"$();
	time:"p"$()]
	request:();
	user:`$();
	success:"b"$();
	duration:"j"$();
	sync:"b"$()
 );
 
logAccess:{[duration;aRequest;isSuccess;isSync]
 ins:(.z.w;.z.p;aRequest;.Q.host[.z.a];isSuccess;duration;isSync);
 access,:ins;
 }
 
.z.po:{
	show ".z.po";
	show x; /input is the new server side handle to the client
	show .z.w; /this is the callback handle to the client. In .z.po, .z.w and the input are the same
	show .Q.host[.z.a]; /convert and display client's IP address (supplied from incoming list of bytes) to the corresponding host name
	show .z.u; /display  client's username (supplied from incoming list of bytes)'
	ins:(x;.z.t;.z.u;.Q.host[.z.a];`$raze string "i"$0x0 vs .z.a;0);
	clients,:ins;
 };
 
/close 
/
The only information on the newly disconnected client is the dead handle to this client
\
.z.pc:{
	show ".z.pc";
	show x; /input is the old server side handle to the disconnected client
	delete from `clients where h = x;
 }; 
 
/synch (get)
/
Display information about the received synch message and the client who sent it
Then actually execute the message and return the result.
The result of .z.pg will implicitly be sent back to the client
\

.z.pg:{
 st:.z.p;
 r:@[.z.pg1;x;{`fail}];
 isSuccess:not r~`fail; 
 et:.z.p;
 duration:"j"$et-st;
 logAccess[duration;x;isSuccess;1b];
 r}

.z.pg1:{[x]
	update number:number+1 from `clients where h=.z.w;
	show ".z.pg";
	show x;
	show .z.w;
	show .Q.host[.z.a];
	show .z.u;
	res:value x; /execute the message
	res /return the result
 };
 
/.z.pg:.z.ps:{value x} 
 
/asynch (set) 
/
Display information about the received asynch message and the client who sent it
Then actually execute the message. There is no point returning anything from this function as the result
will not be sent back to the client. This is because the client sent the message asynch.
\
.z.ps:{
 st:.z.p;
 r:@[.z.ps1;x;{`fail}];
 isSuccess:not r~`fail; 
 et:.z.p;
 duration:"j"$et-st;
 logAccess[duration;x;isSuccess;0b];
 }
.z.ps1:{[x]
	update number:number+1 from `clients where h=.z.w;
	show ".z.ps";
	show x;
	show .z.w;
	show .Q.host[.z.a];
	show .z.u;
	value x; /execute the message
 }; 

 

 