///////////////////////////////////////////////
//  Price European Option using Monte Carlo
///////////////////////////////////////////////

// From kx.com/q/stat/q
// Box-Muller transformation
// Generates random normal variables from uniform distribution
// q's ? rng is multiply-with-carry 
pi:acos -1
nor:{$[x=2*n:x div 2;raze sqrt[-2*log n?1f]*/:(sin;cos)@\:(2*pi)*n?1f;-1_.z.s 1+x]}


// Monte Carlo option pricer
mc_pricer_mwc:{[s0;k;mu;vol;t;sims]
    / daily timesteps
    dt:1%365;
    timesteps:ceiling t%dt;
    / generate the random numbers
    rns:nor sims*timesteps;
    / weiner process
    randomnumbers:sums(timesteps;sims)#rns;
    s:s0*exp[(dt*mu-xexp[vol;2]%2) + randomnumbers*vol*sqrt[dt]];
    / observe value of stock price at last timestep for each simulation to determine payoff
    payoffs:max each ((last s)-k),'0;
    mean_payoff:avg payoffs;
    / discount back to today
    mean_payoff*exp[neg[mu*t]]
    }

